dojo.provide("epages._workaround");

dojo['requireLocalization']("dojo.cldr", "gregorian");

epages._workaround.load = function(module) {
	if (module == 'epages.widget.Calendar' && dojo.version.revision == '0') {

dijit._placeOnScreenAroundRect = function(
	/* DomNode */		node,
	/* Number */		x,
	/* Number */		y,
	/* Number */		width,
	/* Number */		height,
	/* Object */		aroundCorners,
	/* Function */		layoutNode){

	// summary:
	//		Like dijit.placeOnScreenAroundNode(), except it accepts coordinates
	//		of a rectangle to place node adjacent to.

	// TODO: combine with placeOnScreenAroundRectangle()

	// Generate list of possible positions for node
	var choices = [];
	for(var nodeCorner in aroundCorners){
		choices.push( {
			aroundCorner: nodeCorner,
			corner: aroundCorners[nodeCorner],
			pos: {
				x: x + (nodeCorner.charAt(1) == 'L' ? 0 : width),
				y: y + (nodeCorner.charAt(0) == 'T' ? 0 : height)
			}
		});
	}
//Start of workaround
	// only correct popups (calendar) with {'BR':'TR','BL':'TL'}
	if (choices.length == 2 &&
		  choices[0].aroundCorner == 'BR' && choices[0].corner == 'TR' &&
			choices[1].aroundCorner == 'BL' && choices[1].corner == 'TL') {
				choices = choices.reverse();
	}
//End of Workaround
	return dijit._place(node, choices, layoutNode);
};
}
	if (module == 'dijit.Tree' && dojo.version.revision == '20973') {

		//add publish to expand method of tree nodes
		dojo.connect(dijit._TreeNode.prototype, "expand", function() {
			dojo.publish(this.tree.id+'/nodeexpand',[this]);
		});
	} else if (module == 'dojo.cldr.supplemental') {
		dojo.cldr.supplemental.getFirstDayOfWeek = function(/*String?*/locale){
			if (dojo.i18n.normalizeLocale(locale) == djConfig.locale){ 
				return epages.vars.Locale.firstDayOfWeek;
			}
			// summary: Returns a zero-based index for first day of the week
			// description:
			//		Returns a zero-based index for first day of the week, as used by the local (Gregorian) calendar.
			//		e.g. Sunday (returns 0), or Monday (returns 1)

				// from http://www.unicode.org/cldr/data/common/supplemental/supplementalData.xml:supplementalData/weekData/firstDay
				var firstDay = {/*default is 1=Monday*/
					mv:5,
					ae:6,af:6,bh:6,dj:6,dz:6,eg:6,er:6,et:6,iq:6,ir:6,jo:6,ke:6,kw:6,lb:6,ly:6,ma:6,om:6,qa:6,sa:6,
					sd:6,so:6,tn:6,ye:6,
					as:0,au:0,az:0,bw:0,ca:0,cn:0,fo:0,ge:0,gl:0,gu:0,hk:0,ie:0,il:0,is:0,jm:0,jp:0,kg:0,kr:0,la:0,
					mh:0,mo:0,mp:0,mt:0,nz:0,ph:0,pk:0,sg:0,th:0,tt:0,tw:0,um:0,us:0,uz:0,vi:0,za:0,zw:0,
					et:0,mw:0,ng:0,tj:0,
					// variant. do not use?		gb:0,
					sy:4
				};

				var country = dojo.cldr.supplemental._region(locale);
				var dow = firstDay[country];
				return (dow === undefined) ? 1 : dow; /*Number*/
			};
		}
	if(module == 'dijit._Widget' && dojo.version.revision == '20973'){
		dijit._Widget.prototype._deferredConnects = {};
	}
};

dojo.connect(dojo, "require", epages._workaround, "load");

