/*  EPages JavaScript module, $Revision: 1.1.52.1 $
 *  (c) 2006 epages Software GmbH
 *--------------------------------------------------------------------------
 */
dojo.provide("epages.register");
dojo.require("epages.lang.hash");

epages.register = function() {
	if (this.data === undefined){
		this.data = new epages.lang.Hash();
	}
	if (arguments.length == 0) {
		// constructor
		this.data = new epages.lang.Hash();
	} else if (arguments.length == 1) {
		// called as get function
		return this.data.get(arguments[0]);
	} else if (arguments.length == 2) {
		// called as set function
		return this.data.set(arguments[0], arguments[1]);
	}
};

epages.register.prototype = {};
