<?php

require_once('lib/generator/common/AbstractSerializer.php');

abstract class Serializer extends AbstractSerializer
{
  private $file_location;
  protected $extension = "json";

  private $length = 9999;

  private $queue;
  private $limit = 50;
public static function dir_delete($verz, $first = FALSE, $folder = array())
{
    if(!$first){
        $folder[] = $verz;
    }

    $fp = @opendir($verz);

    while ($dir_file = @readdir($fp))
    {
        if (($dir_file == '.') || ($dir_file == '..'))
            continue;

        $neu_file = $verz . '/' . $dir_file;

        if (is_dir($neu_file))
            $folder = Serializer::dir_delete($neu_file, FALSE, $folder);
        else
            @unlink($neu_file);
    }

    @closedir($fp);

    return $folder;
}

    public static function empty_dir($dir_file)
    {
        if (is_dir($dir_file))
        {
            $array = Serializer::dir_delete($dir_file,TRUE);
            $array = array_reverse($array);

            foreach ($array as $elem){
                @rmdir($elem);
            }
        }
    }
  public static function clean($directory) {
    $loc = $directory;
    Serializer::empty_dir($directory);
  }

  public function __construct($directory) {
    $this->queue = array();
    $this->createDir($directory);
    $this->file_location = $directory;      
  }
  public function __destruct() {
    if(file_exists ($this->file_location . '/temp.tmp')) {
        @unlink($this->file_location . '/temp.tmp');
    }
  }
  public function set($id, $value) {
    $this->queue = array($id, $value);
    $this->flush();
  }
  public function createDir($path,$rest=""){
      if($path == ""){
          return true;
      }
      $parts = explode("/",$path);
      if($first = $parts[0]){
        if(!is_dir($rest.$first)){
            mkdir($rest.$first);
        }
        if(strpos($path,"/") === FALSE){
            return true;
        }
        return $this->createDir(substr($path,strpos($path,"/")+1),$rest.$first."/");   
      }
      return false;
  }
  public function flush() {
    $deferred = array();

      list($id, $value) = $this->queue;
      $file_location_a = explode(".",$id);
      $flie_name_current =  strtolower(array_pop($file_location_a));
      $file_location_current =  strtolower(implode("/",$file_location_a));
      $tostring = $this->toString($value, $id);

      if (!$id) {
        debug_print_backtrace();
        die("Called set without an ID\n");
      }

      $lines = array();
      $started = false;
      $header = false;
      $buffer = array();

      $tmp = fopen($this->file_location . '/temp.tmp', 'w');
      foreach ($this->header as $header_line) {
        fwrite($tmp, $header_line . "\n");
      }

        $lines = explode("\n", $tostring);
        foreach ($lines as $line) {
          fwrite($tmp, $this->indent . $line . "\n");
        }

      foreach ($this->footer as $footer_line) {
        fwrite($tmp, $footer_line . "\n");
      }

      fclose($tmp);
      
      if (!file_exists ($this->file_location ."/". $file_location_current)|| !is_dir($this->file_location ."/". $file_location_current))
      { 
         if(!$this->createDir($this->file_location ."/". $file_location_current)){
             //throw new Exception("Failed to create Dictory.");
             $this->queue = array(); 
             return;
         }
      }
      if(false===strpos($flie_name_current,"/")){
      	if(file_exists ($this->file_location."/".$file_location_current."/".$flie_name_current.".".$this->extension)) {
      		@unlink($this->file_location."/".$file_location_current."/".$flie_name_current.".".$this->extension);
      	}
      	rename($this->file_location . '/temp.tmp',$this->file_location."/".$file_location_current."/".$flie_name_current.".".$this->extension);
      }
    $this->queue = array();
  }
}
