/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.presentation.visualaidcontroller $Revision: 1.6.62.1 $

*/
dojo.provide('epages.cartridges.de_epages.presentation.visualaidcontroller');

epages.cartridges.de_epages.presentation.visualaidcontroller = {
	isVisualAidVisible: true,
	visualAidClassNames: ["HideVisualAid", "ShowVisualAid"],
	win: window,

	toggleVisualAid: function() {
		this.isVisualAidVisible = !this.isVisualAidVisible;
		this.setVisualAid(this.isVisualAidVisible);
	},
	getVisualAidClassName: function () {
		return this.visualAidClassNames[this.isVisualAidVisible ? 1 : 0];
	},
	setVisualAid: function(isVisible) {
		var a = this.visualAidClassNames[isVisible ? 1 : 0];
		var r = this.visualAidClassNames[isVisible ? 0 : 1];
		if(this.win.tinyMCE){
			for (var e in this.win.tinyMCE.instances) {
				iDoc=$E(this.win.tinyMCE.instances[e].iframeElement).getIframeDocument();
				dojo.addClass(iDoc.body,a);
				dojo.removeClass(iDoc.body,r);
			}
		}
		dojo.addClass(this.win.document.body,a);
		dojo.removeClass(this.win.document.body,r);
		this.isVisualAidVisible=isVisible;
		dojo.publish('presentation/setVisualAid', [{
			isVisible: this.isVisualAidVisible
		}]);
	}
};

dojo.subscribe("EmbeddedStorefront/onLoad", function(iframe) {
	epages.cartridges.de_epages.presentation.visualaidcontroller.win = iframe.contentWindow;
	epages.cartridges.de_epages.presentation.visualaidcontroller.setVisualAid(epages.cartridges.de_epages.presentation.visualaidcontroller.isVisualAidVisible);
});

dojo.subscribe("EmbeddedStorefront/onChange", function(iframe) {
	epages.cartridges.de_epages.presentation.visualaidcontroller.win = iframe.contentWindow;
	epages.cartridges.de_epages.presentation.visualaidcontroller.setVisualAid(epages.cartridges.de_epages.presentation.visualaidcontroller.isVisualAidVisible);
});
