dojo.provide('epages.cartridges.de_epages.presentation.widget.EditorPlaceholder');
dojo.require("epages.widget");
dojo.require('epages.lang.hash');
dojo.require('epages.string');

dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.EditorPlaceholder",
	[dijit._Widget, dijit._Templated],
	{
		ep_info: '',
		_info: undefined,
		base64: new epages.string.Base64,
		src : epages.vars.StoreRoot + '/BO/icons/general_img_transparentpixel.gif',

		templateString: '<img width="" height="" ep_group="" ep_info="${ep_info}" title="" alt="" style="" class="epItemContent" src="${src}" />',

		decodeInfo: function(string) {
			if(string && string != ''){
				var info = eval("(" + this.base64.decode(string) + ")");
				if (info.formData !== undefined){ 
					info.formData = $H(info.formData);
				}
				return info;
			}
	},

		postMixInProperties:function(){
			this.inherited("postMixInProperties", arguments);
			this._info = this.decodeInfo(this.ep_info);
		},
		postCreate: function(){
			this.inherited("postCreate", arguments);
			if(this._info && this._info != ''){
				if(this._info.width == "100%") {
					this.domNode.setAttribute('width',this.domNode.parentNode.offsetWidth);
				}else {
					this.domNode.setAttribute('width',this._info.width);
				}
				if(this._info.height == "100%") {
					this.domNode.setAttribute('height',this.domNode.parentNode.offsetHeight);
				}else {
					this.domNode.setAttribute('height',this._info.height);
				}
				this.domNode.setAttribute('alt',this._info.title);
				this.domNode.setAttribute('title',this._info.title);
				this.domNode.style.backgroundImage = 'url('+epages.locationWebRoot(this._info.preview)+')';
				this.domNode.setAttribute('ep_group',this._info.group);
				var width = (this._info.width.toString().match(/%/)) ? this._info.width : this._info.width+'px';
				var height = (this._info.height.toString().match(/%/)) ? this._info.height : this._info.height+'px';
				var epStyle="background:url('"+this._info.preview+"'); width:"+width+"; height:"+height+";";
				this.domNode.setAttribute('ep_style',epStyle);
			}
		}
	}
);