/*
	Copyright (c) 2006-2008, epages Software GmbH
	All Rights Reserved.

  epages.cartridges.de_epages.product.basketlink $Revision: 1.3.8.1 $

*/
dojo.provide("epages.cartridges.de_epages.product.basketlink");
dojo.require('epages.localize');

epages.cartridges.de_epages.product.basketlink = {

	valueUp : function( domNode, interval, minOrder ) {
		var value = epages.localize.parseNumber(domNode.value);
		if ( !value ){
			value = minOrder-1;
		}
		if ( value < minOrder ){
			value = minOrder-1;
		}
		var factor = Math.round((value-minOrder)/interval) + 1;
		domNode.value = epages.localize.formatNumber(minOrder+factor*interval);
	},
	valueDown : function( domNode, interval, minOrder ) {
		var value = epages.localize.parseNumber(domNode.value);
		if ( !value ){
			value = 0;
		}
		var factor = Math.round((value-minOrder)/interval) - 1;
		if ( factor < 0 ){
			factor = 0;
		}
		domNode.value = epages.localize.formatNumber(minOrder+factor*interval);
	}
};