-- #202
CREATE TABLE feature (
     featureid            integer  not null
,    cartridgeid          integer  not null
,    maxvalue             integer  not null
,    unitid               integer  null
,    verifyfunctionname   varchar(255)  null
,    allowtoexceed        bool  not null

,   constraint pk_feature                       primary key (featureid)
,   constraint fk_feature_cartridge             foreign key (cartridgeid)
        references cartridge                        (cartridgeid)
,   constraint fk_feature_object                foreign key (featureid)
        references object                           (objectid)
,   constraint fk_feature_unitofmeasurement     foreign key (unitid)
        references unitofmeasurement                (unitid)
)
GO
CREATE INDEX i_feature_cartridge ON feature (cartridgeid)
GO
