-- #203
CREATE TABLE shopfeature (
     shopid               integer  not null
,    featureid            integer  not null
,    maxvalue             integer  not null
,    currentvalue         integer  not null
,    isvisible            bool  not null
,    isdirty              bool  not null

,   constraint pk_shopfeature                   primary key (shopid,featureid)
,   constraint fk_shopfeature_feature           foreign key (featureid)
        references feature                          (featureid)
,   constraint fk_shopfeature_shop              foreign key (shopid)
        references shop                             (shopid)
)
GO
CREATE INDEX i_shopfeature_feature ON shopfeature (featureid)
GO
