/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.design.widget.Designtoolitem $Revision: 1.3.4.1 $

*/
dojo.provide("epages.cartridges.de_epages.design.widget.Designtoolitem");
dojo.require('epages.widget.Tooltip');

dojo.declare(
	"epages.cartridges.de_epages.design.widget.Designtoolitem",
	[dijit._Widget, dijit._Templated, dijit._Contained],
	{
		/**
		 * public properties
		 */
		label: '',
		infoText: '',
		iconSrc: '',
		objectId: '',
		tooltipWidget: undefined,
		 /**
		 * widget properties
		 */
		imagePath         :  epages.themeUrl('images'),
		templatePath    : dojo.moduleUrl('epages.cartridges.de_epages.design.widget','templates/Designtoolitem.html'),

		postCreate: function(){
			dojo.setSelectable(this.domNode, false);
			if(this.label){
				this.containerNode.innerHTML=this.label;
			}
			if(this.label != "") {
				var ttContent= "";
				if(this.infoText && this.infoText != ""){
					ttContent = "<b>"+this.label+"</b><br />"+this.infoText;
				}else{
					ttContent = this.label;
				}
				this.tooltipNode.innerHTML= ttContent;
				var tt = new epages.widget.Tooltip({},this.tooltipNode);
				this.tooltipWidget = tt;
			}
		},
		onClick: function() {
		},

		_onHover: function(){
			dojo.addClass(this.domNode, 'dijitMenuItemHover');
		},

		_onUnhover: function(){
			dojo.removeClass(this.domNode, 'dijitMenuItemHover');
		}
	}
);