dojo.provide("epages.data.ForestStoreModel");

dojo.require("dijit.tree.ForestStoreModel");

dojo.declare("epages.data.ForestStoreModel", dijit.tree.ForestStoreModel, {
	queryOptions: null,

	// =======================================================================
	// Events from data store
	applyQuery: function(/*Object*/query,/*Object?*/queryOptions,/*Object?*/sort){
		this.store.fetch({
			query: query || this.query,
			sort: sort || this.sort,
			queryOptions: queryOptions || this.queryOptions,
			onComplete: dojo.hitch(this, function(newChildren){
				this.root.children = newChildren;
				this.onChildrenChange(this.root, newChildren);
			})
		});
	}
});