/*
	Copyright (c) 2006-2009, epages Software GmbH
	All Rights Reserved.

	epages.widget.DragDropElementlistitem $Revision: 1.2.4.1 $
*/

dojo.provide("epages.widget.DndElementlistitem");
dojo.require("epages.widget.Elementlistitem");

dojo.declare("epages.widget.DndElementlistitem", [epages.widget.Elementlistitem],  {
		/**
		 * public methods
		 */
		selectOn    : 'onmousedown',
		_isDragging : false,

		postCreate: function() {
			this.inherited("postCreate", arguments);

			// connect events
			this.connect(this.domNode, "onmousedown", this, '_onMouseDown');
			this.connect(this.domNode, "onmouseup", this, '_onMouseUp');
		},

		_onMouseDown : function(evt) {
			this.getParent()._itemOnMouseDown(this, this.isSelected, evt);
		},

		_onMouseUp : function(evt) {
			this.getParent().dndDeSelectItem(this, this.isSelected, evt);
		},

		_onClick: function(evt) {	// in this case also mouse down
				this.getParent().dndSelectItem(this, this.isSelected, evt);
		}

	}
);
