/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.externalcontent.boerse $Revision: 1.10.2.2 $

*/
dojo.provide('epages.cartridges.de_epages.externalcontent.boerse');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.io.text');

epages.cartridges.de_epages.externalcontent.Boerse = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.Boerse,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass      : 'epages.cartridges.de_epages.externalcontent.Boerse',
	title             : 'Aktienkursabfrage',
	width             : 130,
	height            : 90,
	templateselection : 'boersetemplate2',
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_boerse.png',

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			templateselection   : this.templateselection
		});
		return info;
	},
	contentString: function (info, ispreview) {
		var textIo = new epages.io.Text();
		if(info.formData.get('BoerseTemplate')){
			var radiovalues = info.formData.get('BoerseTemplate');
			for( var i=0,l=radiovalues.length ; i<l ; i++ ){
				if(radiovalues[i] !== ""){
					info.templateselection = radiovalues[i];
				}
			}
		}
		var returnstring = '<div class="GadgetBoerse">' + textIo.load(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', info.templateselection+'.html'))+'</div>';
		if(ispreview){
			returnstring = '<link href="'+epages.vars.StoreRoot+'/SF/Gadgets/BoersePreview.css" rel="stylesheet" type="text/css" />' + returnstring;
		}
		return returnstring;
	}

});