/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.externalcontent.wikipverkehrsinfoediade $Revision: 1.8.2.1 $

*/
dojo.provide('epages.cartridges.de_epages.externalcontent.verkehrsinfo');
dojo.require('epages.cartridges.de_epages.design.mcecontent');

epages.cartridges.de_epages.externalcontent.Verkehrsinfo = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.Verkehrsinfo,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass       : 'epages.cartridges.de_epages.externalcontent.Verkehrsinfo',
	title              : 'Verkehrsinfo.de',
	width              : 160,
	height             : 90,
	txtColor					 : '4A5184',
	bgColor            : 'ffffff',
	mapWidth					 : 120,
	mapHeight					 : 200,
	roadWorksSrc       : 'http://www.verkehrsinfo.de/bausearch.php',//an diesen Link werden noch Parameter angefgt
	trafficJamSrc      : 'http://www.verkehrsinfo.de/newsearch.php',// an den auch
	mapSrc						 : 'http://www.verkehrsinfo.de/newstauuebersicht.php',//hier auch
	country						 : 1,
	preview            : epages.vars.StoreRoot + '/BO/icons/navelement_verkehrsinfo.png',
	selection          : 'TrafficJamMap',

	contentString: function (info, ispreview) {
		var returnstring ="";
		if(info.formData.get('VerkehrsinfoSelection')){
			var radiovalues = info.formData.get('VerkehrsinfoSelection');
			for( var i=0,l=radiovalues.length ; i<l ; i++ ){
				if(radiovalues[i] !== ""){
					info.selection = radiovalues[i];
				}
			};
			this.txtColor = info.formData.get('verkehrsinfoTxtColor')[0].substring(1);
			this.bgColor = info.formData.get('verkehrsinfoBgColor')[0].substring(1);
			if(info.selection == "RoadWorksSearch") {
				var src = this.roadWorksSrc + '?width=' + this.width + '&height=' + this.height + '&color=' + this.txtColor + '&bgcolor=' + this.bgColor + '&country=' + this.country;
				returnstring = '<iframe src="'+ epages.getIframeWrapperUrl(src, 'iso-8859-1') + '" width="' + this.width + '" height="' + this.height + '" frameborder="0" border="0" scrolling="No"></iframe>';
			}
			else if(info.selection == "TrafficJamSearch"){
				var src = this.trafficJamSrc + '?width=' + this.width + '&height=' + this.height + '&color=' + this.txtColor + '&bgcolor=' + this.bgColor + '&country=' + this.country;
				returnstring = '<iframe src="'+ epages.getIframeWrapperUrl(src, 'iso-8859-1') + '" width="' + this.width + '" height="' + this.height + '" frameborder="0" border="0" scrolling="No"></iframe>';
			}
			else if(info.selection == "TrafficJamMap"){
				var src = this.mapSrc + '?country=' + this.country;
				returnstring = '<iframe src="'+ epages.getIframeWrapperUrl(src, 'iso-8859-1') + '" width="' + this.mapWidth + '" height="' + this.mapHeight + '" frameborder="0" border="0" scrolling="No"></iframe>';
			}
		}
		else{
			var src = this.mapSrc + '?country=' + this.country;
			returnstring = '<iframe src="'+ epages.getIframeWrapperUrl(src, 'iso-8859-1') + '" width='+this.mapWidth+' height='+this.mapHeight+' frameborder="0" border="0" scrolling="No" ></iframe>';
		}
		return returnstring;
	}
});