/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.externalcontent.waehrung $Revision: 1.8.44.1 $

*/
dojo.provide('epages.cartridges.de_epages.externalcontent.waehrung');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.io.text');

epages.cartridges.de_epages.externalcontent.Waehrung = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.Waehrung,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass      : 'epages.cartridges.de_epages.externalcontent.Waehrung',
	title             : 'Waehrungsrechner',
	width             : 400,
	height            : 200,
	templatestring    : '',
	templatefile1     : 'waehrungtemplate.html',
	templatefile2     : 'waehrungtemplate2.html',
	acctualtemplate   : 'waehrungtemplate2.html',
	preview           : epages.vars.StoreRoot + '/BO/icons/navelement_waehrung.png',
	selection         : 'template1',

	contentString: function (info, ispreview) {
		if(info.formData.get('WaehrungRadio')){
			var radiovalues = info.formData.get('WaehrungRadio');
			for( var i=0,l=radiovalues.length ; i<l ; i++ ){
				if(radiovalues[i] !== undefined){
					info.selection = radiovalues[i];
				}
			};
			if(info.selection == 'template1'){
				this.acctualtemplate = this.templatefile1;
			}
			if(info.selection == 'template2'){
				this.acctualtemplate = this.templatefile2;
			}
		}
		var textIo = new epages.io.Text();
		var returnstring = textIo.load(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent',''+this.acctualtemplate));
		return returnstring;
	}

});

