-- #102
CREATE TABLE googleadwordscode (
    googleadwordscodeid  int           not null
,   couponcode           varchar(32)   not null
,   shopid               int           null
,   isused               tinyint       not null

,   constraint pk_googleadwordscode             primary key (googleadwordscodeid)
,   constraint fk_googleadwordscode_shop        foreign key (shopid)
        references shop                             (shopid)
)
GO
CREATE INDEX i_shopid ON googleadwordscode (shopid)
GO
CREATE INDEX i_isused ON googleadwordscode (isused)
GO
