/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

  epages.cartridges.de_epages.presentation.* $Revision: 1.6.8.1 $

*/
dojo.provide("epages.cartridges.de_epages.presentation.icon");

epages.cartridges.de_epages.presentation.icon.getIconFileName = function(classAlias, isVisible, isProduct, /* ? string */ size) {
	var iSize = (size) ? size : 's';
	if (isVisible === undefined || isVisible == null){ 
		isVisible = true;
	}
	if (isProduct === undefined){ 
		isProduct = false;
	}
	var isVisible = isVisible ? '.png' : '_inactive.png';
	if(isProduct){  
		return 'object_ico_'+iSize+'_product' + isVisible;
	}
	if(classAlias){ 
		return 'object_ico_'+iSize+'_' + classAlias.toLowerCase() + isVisible;
	}
	return 'general_img_transparentpixel.png';
}

epages.cartridges.de_epages.presentation.icon.getIconSpriteName = function(classAlias, isVisible, isProduct, /* ? string */ size) {
	var iSize = (size) ? size : 's';
	if (isVisible === undefined || isVisible == null){ 
		isVisible = true;
	}
	if (isProduct === undefined){ 
		isProduct = false;
	}
	var isVisible = isVisible ? '' : '_inactive';
	if(isProduct){  
		return 'object_ico_'+iSize+'_product' + isVisible;
	}
	if(classAlias){ 
		return 'object_ico_'+iSize+'_' + classAlias.toLowerCase() + isVisible;
	}
	return '';
}

